QGIS Application - Bug report #9315
Field Calculator, slow performance with 2.1.0-104
2014-01-09 02:20 PM - joe larson

Status: Closed

Priority: Low

Assignee: Matthias Kuhn

Category: Vectors

Affected QGIS version:master Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 17922
Description

using OSGeo4W64, 2.1.0-104 while trying to update a field in a large dataset (~300MB) with the Field Calculator ...very slow performance
was experienced.

Another user in IRC, “Irssvt’ also confirmed experiencing this with this dataset (CARTO1_Lin_6CNivelD.zip) available here #8725-23

Related issues:
Related to QGIS Application - Bug report # 9519: Rollback operations slow if ... Closed 2014-02-09
Related to QGIS Application - Bug report # 9509: Discarding edits freezes qgi... Closed 2014-02-07

Associated revisions

Revision ccde424d - 2014-01-10 12:51 AM - Jiirgen Fischer

reduce debugging noise in attribute table (fixes #9315)

Revision 3ba33d73 - 2014-01-30 10:30 PM - Matthias Kuhn

[attrtable] Only update table at the end of an edit command
Fix #9315

Revision d378f942 - 2014-01-30 10:30 PM - Matthias Kuhn
[attrtable] No checks when the model is not based on a request

Huge speedup
Fix #9315

History

#1 - 2014-01-09 02:47 PM - joe larson
- Operating System changed from Windows 7 to Windows
- OS version setto 7

This only occurs when Attribute Table is open.

#2 - 2014-01-09 02:59 PM - Nathan Woodrow
- Assignee set to Matthias Kuhn
#3 - 2014-01-09 03:52 PM - Jiirgen Fischer
- Status changed from Open to Closed

Fixed in changeset commit:"ccde424dc14ebc82c97e62d3568b1cf15f3bfda9"”.

#4 - 2014-01-09 10:29 PM - Matthias Kuhn

I've noticed a similar latency recently, but in a release build (i.e. without debug output, so Jirgens commits should not make any differece there). Adding a

new calculated column to ~1mio rows was incredibly slow. This was with a build from before the recent changes concerning reliable signalling of attribute

changes. | hope to get time to looking into batch updating.

#5 - 2014-01-13 06:42 PM - dr -

- Operating System deleted (Windows)

- Status changed from Closed to Reopened
- OS version deleted (7)

Also noticed that slow performance occurs only when Attribute Table is open (master, Ubuntu).

#6 - 2014-01-26 01:41 PM - Giovanni Manghi
- Category set to Vectors
- Target version set to Future Release - High Priority

dr - wrote:

Also noticed that slow performance occurs only when Attribute Table is open (master, Ubuntu).

confirmed very slow field calculator performance when table is open.

#7 - 2014-01-26 01:47 PM - Matthias Kuhn

Is it a regression?

#8 - 2014-01-26 02:16 PM - Giovanni Manghi

Matthias Kuhn wrote:

Is it a regression?

it seems faster in qgis 2.0.1

#9 - 2014-01-26 02:30 PM - Matthias Kuhn
| could (partially) revert commit:5¢38775 which could probably help here. But this would in turn reintroduce bug #9268 (updates not pushed to the attribute
table)
In the future | would like to have a solution which solves both. For now somebody has to decide, what is more important (or agree on e.g. a threshold

feature count for which live-propagating will be turned on/off)

http://lists.osgeo.org/pipermail/ggis-developer/2014-January/030018.html

#10 - 2014-01-29 02:54 PM - Giovanni Manghi

Matthias Kuhn wrote:

I could (partially) revert commit:5c38775 which could probably help here. But this would in turn reintroduce bug #9268 (updates not pushed to the
attribute table)
In the future | would like to have a solution which solves both. For now somebody has to decide, what is more important (or agree on e.g. a threshold

feature count for which live-propagating will be turned on/off)

http.//lists.osgeo.org/pipermail/qgis-developer/2014-January/030018.html|

personally if | have to choose | would prefer speed (in table edits) rather than #9268 fixed.

#11 - 2014-01-30 06:32 AM - Matthias Kuhn

| have created a branch which could potentially fix both issues, but | did not have any time at all to test it.

If somebody is able to test this and give a feedback... It would be great to have these things solved, but didn't even dare to create a pull request so far.

https://github.com/matthias-kuhn/QGIS/tree/tblspeed

#12 - 2014-01-30 01:33 PM - Matthias Kuhn

- Status changed from Reopened to Closed

Fixed in changeset commit:"d378f942a50ad25cc24570e125ea3724e09d79d6".

#13 - 2014-01-30 01:37 PM - Matthias Kuhn
- Status changed from Closed to Reopened

My propsed fix was based on wrong assumptions, the main reason for the bad performance was not the fix for #9268 but another change introduced for the

relations, which led to tons of unnecessary requests. Fixing that brought back an acceptable speed and the proposed fix implemented this morning gave

another remarkable speed boost.

Please help testing thiese fixes and report any related bugs or reopen if this issue should still not be solved for any reason.

#14 - 2014-01-30 01:37 PM - Matthias Kuhn

- Status changed from Reopened to Closed

2025-04-27 3/5


http://lists.osgeo.org/pipermail/qgis-developer/2014-January/030018.html
http://lists.osgeo.org/pipermail/qgis-developer/2014-January/030018.html
https://github.com/matthias-kuhn/QGIS/tree/tblspeed

#15 - 2014-02-01 01:42 PM - Salvatore Larosa

Hi Matthias,

| just noticed that with large shapefiles (over ~70k features)

when turn off the edit mode and you choose "close without saving" QGIS freezes (not crashes).

#16 - 2014-02-02 01:08 AM - Giovanni Manghi

Salvatore Larosa wrote:

Hi Matthias,

| just noticed that with large shapefiles (over ~70k features)

when turn off the edit mode and you choose "close without saving" QGIS freezes (not crashes).

Hi Matthias and Salvatore,

are the fixes already committed in master or to test | have to use Matthias branch?

thanks!

#17 - 2014-02-02 01:27 AM - Salvatore Larosa

Giovanni Manghi wrote:

are the fixes already committed in master or to test | have to use Matthias branch?

Yes, they are in master branch now.

#18 - 2014-02-07 11:42 AM - Giovanni Manghi
Salvatore Larosa wrote:
Hi Matthias,

I just noticed that with large shapefiles (over ~70k features)
when turn off the edit mode and you choose "close without saving" QGIS freezes (not crashes).

very true, when discarding edits it take ages to exit the freeze state.

#19 - 2014-02-09 04:24 AM - Matthias Kuhn

| noticed the same. This is due to the undo operation requesting all the features in single requests AFAICT.

Please note that this also happens with the attribute table closed and should therefore be treated as a separate issue.

See #9519
#20 - 2014-02-09 05:28 AM - Jiirgen Fischer
Matthias Kuhn wrote:

Please note that this also happens with the attribute table closed and should therefore be treated as a separate issue.

See #9519

Giovanni already filed #9509.

#21 - 2017-08-08 01:05 AM - Jiirgen Fischer
- Description updated

- Priority changed from Severe/Regression to Low
